[//]: # " Copyright (c) 2018, 2019 Oracle and/or its affiliates. All rights reserved. "
[//]: # "  "
[//]: # " This program and the accompanying materials are made available under the "
[//]: # " terms of the Eclipse Distribution License v. 1.0, which is available at "
[//]: # " http://www.eclipse.org/org/documents/edl-v10.php. "
[//]: # "  "
[//]: # " SPDX-License-Identifier: BSD-3-Clause "

# Fast Infoset

Fast Infoset Project, an Open Source implementation of the Fast Infoset Standard for Binary XML.

The Fast Infoset specification ([ITU-T Rec. X.891](https://www.itu.int/rec/T-REC-X.891/en)
| [ISO/IEC 24824-1](https://www.iso.org/standard/41327.html)) describes an open,
standards-based "binary XML" format that is based on the [XML Information Set](https://www.w3.org/TR/xml-infoset/).

For background, see the Fast Infoset article at Oracle Tech-Network [Fast Infoset](http://www.oracle.com/technetwork/articles/javase/fastinfoset-139262.html)

### Limitations

#### Base64 Optimization

The Base64 optimization only applies to schema-defined (or WSDL-defined) elements.
It does *not* apply to attribute values or element values, which are not defined in the schema
(for example, those generated by the XWSS library). Moreover, this optimization is turned off when
handlers are defined.

#### XWSS Library Optimizations

Certain optimizations in the XWSS library may not be available when Fast Infoset
is turned on.
